// Generated by delombok at Wed Jan 24 14:17:21 UTC 2024
package gov.cms.fiss.pricers.fqhc.core.tables;

import gov.cms.fiss.pricers.common.csv.CsvContentReader;
import gov.cms.fiss.pricers.common.csv.CsvIngestionConfiguration;
import gov.cms.fiss.pricers.common.csv.LookupGenerator;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.List;
import java.util.NavigableMap;
import java.util.TreeMap;

/**
 * Creates the lookup table needed for IOP Rate per year.
 */
public class IopPaymentRateTableEntryLookupGenerator {
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  private static final org.slf4j.Logger LOGGER = org.slf4j.LoggerFactory.getLogger(IopPaymentRateTableEntryLookupGenerator.class);
  private final CsvContentReader<IopPaymentRateTableEntry> contentProvider = new CsvContentReader<>(IopPaymentRateTableEntry.class).customizeSchema(CsvContentReader.HEADER_ROW_CUSTOMIZER);

  public IopPaymentRateTableEntryLookupGenerator(CsvIngestionConfiguration csvIngestionConfiguration) {
    if (!csvIngestionConfiguration.isValidationEnabled()) {
      contentProvider.disableValidation();
    }
  }

  /**
   * Generates the lookup cross-reference from the specified source.
   *
   * @param csvFilename the file to process
   * @return the generated lookup
   */
  public NavigableMap<LocalDate, BigDecimal> generate(String csvFilename) {
    final List<IopPaymentRateTableEntry> content = contentProvider.read(csvFilename);
    return LookupGenerator.generateMap(IopPaymentRateTableEntry::getEffectiveDate, IopPaymentRateTableEntry::getRateValue, content, TreeMap::new);
  }
}
